import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrHomeworkprocessingtask {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  StudentId!: IType<number, bigint>;
  HomeworkId!: IType<number, bigint>;
  TaskType!: number;
  Status!: number;
  Priority!: IType<number, bigint>;
  Error?: string;
  LastScanTime!: IType<number, bigint>;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  Date?: Date;
}

export const IcrHomeworkprocessingtaskSchema = defineEntity({
  class: IcrHomeworkprocessingtask,
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    StudentId: p.bigint().name('StudentId').columnType('bigint').comment('学生编号'),
    HomeworkId: p.bigint().name('HomeworkId').columnType('bigint').comment('作业Id'),
    TaskType: p.integer().name('TaskType'),
    Status: p.integer().name('Status').comment('状态'),
    Priority: p.bigint().name('Priority').columnType('bigint').comment('优先级'),
    Error: p.string().name('Error').nullable().comment('异常信息'),
    LastScanTime: p.bigint().name('LastScanTime').columnType('bigint').comment('上次扫描时间'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    Date: p.datetime().name('Date').length(3).nullable().comment('时间'),
  },
});
